2010-02-04  Richard Guenther  <rguenther@suse.de>

	PR rtl-optimization/42952
	* dse.c (const_or_frame_p): Remove MEM handling.

2010-02-04  Nick Clifton  <nickc@redhat.com>

	* config/mn10300/mn10300.c (TARGET_ASM_OUTPUT_MI_THUNK): Define.
	(TARGET_ASM_CAN_OUTPUT_MI_THUNK): Define.
	(function_arg): Use NULL_RTX and FIRST_ARGUMENT_REGNUM.
	(mn10300_asm_output_mi_thunk): New function.
	(mn10300_can_output_mu_thunk): New function.
	* config/mn10300/mn10300.h (FIRST_ARGUMENT_REGNUM): Define.
	(FUNCTION_ARG_REGNO_P): Fix comment.  Accept d0 and d1.
	(FUNCTION_ARG): Delete incorrect comment.

2010-02-03  Jason Merrill  <jason@redhat.com>

	PR c++/40138
	* fold-const.c (operand_equal_p): Handle erroneous types.

2010-02-03  Kaushik Phatak  <kaushik.phatak@kpitcummins.com>

	* config/h8300/h8300.md (can_delay): Fix attibute condition.

2010-02-03  Vladimir Makarov  <vmakarov@redhat.com>

	PR rtl-optimization/42941
	* sched-deps.c (setup_insn_reg_pressure_info): Use xcalloc instead
	of xmalloc.

2010-02-03  Jason Merrill  <jason@redhat.com>

	PR c++/35652
	* builtins.c (c_strlen): Use EXPR_LOCATION in diagnostics.

2010-02-03  Alexandre Oliva  <aoliva@redhat.com>

	PR debug/42896
	* cselib.h (struct cselib_val_struct): Add uid.  Rename value to
	hash.
	(cselib_reset_table): Renamed from...
	(cselib_reset_table_with_next_value): ... this.
	(cselib_get_next_uid): Renamed from...
	(cselib_get_next_unknown_value): ... this.
	* cselib.c (next_uid): Renamed from...
	(next_unknown_value): ... this.
	(cselib_clear_table): Adjust.
	(cselib_reset_table): Adjust.  Renamed from...
	(cselib_reset_table_with_next_value): ... this.
	(cselib_get_next_uid): Adjust.  Renamed from...
	(cselib_get_next_unknown_value): ... this.
	(get_value_hash): Use hash.
	(cselib_hash_rtx): Likewise.
	(new_cselib_val): Adjust.  Set and dump uid.
	(cselib_lookup_mem): Pass next_uid as hash.
	(cselib_subst_to_values): Likewise.
	(cselib_log_lookup): Dump uid.
	(cselib_lookup): Pass next_uid as hash.  Adjust.
	(cselib_process_insn): Adjust.
	(cselib_init): Initialize next_uid.
	(cselib_finish): Adjust.
	(dump_cselib_table): Likewise.
	* dse.c (canon_address): Dump value uid.
	* print-rtl.c (print_rtx): Print value uid.
	* var-tracking.c (VARIABLE_HASH_VAL): Dropped.
	(dvuid): New type.
	(dv_uid): New function, sort of renamed from...
	(dv_htab_hash): ... this, reimplemented in terms of it and...
	(dv_uid2hash): ... this.  New.
	(variable_htab_eq): Drop excess assertions.
	(tie_break_pointers): Removed.
	(canon_value_cmp): Compare uids.
	(variable_post_merge_New_vals): Print uids.
	(vt_add_function_parameters): Adjust.
	(vt_initialize): Reset table.  Adjust.

2010-02-03  Richard Guenther  <rguenther@suse.de>

	PR tree-optimization/42944
	* tree-ssa-alias.c (ref_maybe_used_by_call_p_1): Handle
	calloc.
	(call_may_clobber_ref_p_1): Likewise.  Properly handle
	malloc and calloc clobbering errno.

2010-02-03  Steven Bosscher  <steven@gcc.gnu.org>

	* doc/invoke.texi: Fix name of sched1 dump.

	* opts.c (decode_options): Set flag_tree_switch_conversion
	only conditionally on optimize >= 2.

	* gcse.c: Assorted comment fixes in pass description.

2010-02-03  Anthony Green  <green@moxielogic.com>

	* config/moxie/moxie.c (moxie_asm_trampoline_template): Introduce
	nop padding in order to maintain alignment of storage location of
	target function address.
	(moxie_trampoline_init): Store target function address at newly
	aligned location.
	* config/moxie/moxie.h (TRAMPOLINE_ALIGNMENT): Increase alignment
	to 32.
	(TRAMPOLINE_SIZE): Increase size by 2 bytes for alignment padding.

2010-02-03  Richard Guenther  <rguenther@suse.de>

	PR middle-end/42927
	* tree-cfg.c (verify_gimple_assign_binary): Fix shift verification.

2010-02-03  Rainer Orth  <ro@CeBiTec.Uni-Bielefeld.DE>

	* config.gcc: Reenable check for obsolete targets.
	Obsolete alpha*-dec-osf4*, alpha*-dec-osf5.0*, mips-sgi-irix5*,
	mips-sgi-irix6.[0-4]*.

2010-02-02  Nick Clifton  <nickc@redhat.com>

	* config/rx/rx.c (rx_is_legitimate_constant): Treat a maximum
	constant size of 4 as being the same as 0.
	* doc/invoke.texi (RX Options): Document that -mmax-constant-size
	can take values in the range 0..4.

2010-02-02  Jack Howarth  <howarth@bromo.med.uc.edu>

	PR java/41991
	* unwind-dw2-fde-darwin.c: Re-export _Unwind_FindEnclosingFunction()
	as _darwin10_Unwind_FindEnclosingFunction().
	* libgcc-libsystem.ver: New.

2010-02-01  Vladimir Makarov  <vmakarov@redhat.com>

	PR target/41399
	* sched-deps.c (sched_analyze_insn): Ignore fixed registers for
	implicitly set registers.

2010-02-01  Richard Earnshaw  <rearnsha@arm.com>

	* arm.c (FL_FOR_ARCH_7A): is also a superset of ARMv6K.
	(arm_override_options): Allow automatic selection of the thread
	pointer register if thumb2.
	(legitimize_pic_address): Improve code sequences for Thumb2.
	(arm_call_tls_get_addr): Likewise.
	(legitimize_tls_address): Likewise.
	* arm.md (pic_load_addr_arm): Delete.  Replace with ...
	(pic_load_addr_32bit): ... this.  New named pattern.
	* thumb2.md (pic_load_addr_thumb2): Delete.
	(pic_load_dot_plus_four): Delete.
	(tls_load_dot_plus_four): New named pattern.

2010-02-01  Rainer Orth  <ro@CeBiTec.Uni-Bielefeld.DE>

	PR libgomp/29986
	* doc/install.texi (Specific): Add sparc-sun-solaris2.10 entry.
	Document fix for TLS bug.

2010-01-31  Richard Guenther  <rguenther@suse.de>

	* tree-sra.c (ptr_parm_has_direct_uses): Rewrite to be
	conservatively correct.

2010-01-31  John David Anglin  <dave.anglin@nrc-cnrc.gc.ca>

	PR target/42850
	Revert:
	2010-01-02  John David Anglin  <dave.anglin@nrc-cnrc.gc.ca>

	* config/pa/t-slibgcc-dwarf-ver (SHLIB_SOVERSION): Bump by two.

2010-01-31  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* doc/install.texi: Update recommended GMP/MPFR/MPC versions.

2010-01-31  Kai Tietz  <kai.tietz@onevision.com>

	* config.gcc: Adjust order of makefile fragments for mingw targets.

2010-01-31  Richard Guenther  <rguenther@suse.de>

	PR middle-end/42898
	* gimplify.c (gimplify_init_constructor): For volatile LHS
	initialize a temporary.

2010-01-31  Matthias Klose  <doko@ubuntu.com>

	* configure.ac: Fix __stack_chk_fail check for cross builds configured
	--with-headers
	* configure: Regenerate.

2010-01-29  Eric Botcazou  <ebotcazou@adacore.com>

	* tree-ssa-alias.c (same_type_for_tbaa): Return -1 if the types have
	the same alias set and their sizes different constantness.
	(aliasing_component_refs_p): Revert 2009-10-24 change.

2010-01-29  Rainer Orth  <ro@CeBiTec.Uni-Bielefeld.DE>

	* config/sparc/sparc.c (sparc_elf_asm_named_section): Declare decl
	unused.

2010-01-29  Richard Guenther  <rguenther@suse.de>

	* tree-ssa-ccp.c (ccp_fold_stmt): Unshare values we substitute.
	Assert we successfully updated the call.

2010-01-29  Jakub Jelinek  <jakub@redhat.com>

	PR rtl-optimization/42889
	* df.h (df_set_bb_dirty_nonlr): New prototype.
	* df-core.c (df_set_bb_dirty_nonlr): New function.
	* df-scan.c (df_insn_rescan): Call it instead of
	df_set_bb_dirty for DEBUG_INSNs.

2010-01-29  Richard Guenther  <rguenther@suse.de>

	PR middle-end/37448
	* ipa-inline.c (cgraph_decide_inlining_incrementally): Avoid
	quadratic behavior in most cases.

2010-01-28  Uros Bizjak  <ubizjak@gmail.com>

	PR target/42891
	* config/i386/i386.c (ix86_expand_int_movcc): Convert tmp to SImode
	in the call to gen_x86_movsicc_0_m1.

2010-01-28  Richard Guenther  <rguenther@suse.de>

	PR tree-optimization/42871
	* tree-ssa-pre.c (phi_translate_set): Make sure to retain
	leaders.

2010-01-28  Richard Guenther  <rguenther@suse.de>

	* tree-ssa-ccp.c (ccp_fold_stmt): Fold calls and propagate
	into call arguments.

2010-01-28  Richard Guenther  <rguenther@suse.de>

	PR middle-end/42883
	* tree-cfgcleanup.c (remove_forwarder_block): Do not remove
	the forwarder if the destination is an EH landing pad.

2010-01-28  Razya Ladelsky  <razya@il.ibm.com>

	* tree-parloops.c (transform_to_exit_first_loop): Update the basic
	block list passed to gimple_duplicate_sese_tail.
	(parallelize_loops): Avoid parallelization when the function
	has_nonlocal_label.
	Avoid parallelization when the preheader is IRREDUCIBLE.
	Try to optimize when estimated_loop_iterations_int is unresolved.
	Add the loop's location to the dump file.
	* tree-cfg.c (add_phi_args_after_redirect): Remove.
	(gimple_duplicate_sese_tail): Remove the check for the latch.
	Redirect nexits to the exit block.
	Remove handling of the incoming edges to the latch.
	Redirect the backedge from the copied latch to the exit bb.

2010-01-28  Michael Matz  <matz@suse.de>

	PR target/42881
	* config/i386/i386.c (ix86_expand_vector_init_duplicate):
	Wrap force_reg into a sequence, emit it before user.

2010-01-28  Stephen Thomas  <stephen.thomas@arm.com>

	* config/arm/arm.md (bswapsi2): Add support for bswapsi2.
	(arm_rev): New.
	(arm_legacy_rev): Likewise.
	(thumb_legacy_rev): Likewise.

2010-01-27  Jakub Jelinek  <jakub@redhat.com>

	* dwarf2out.c (mem_loc_descriptor): Remove special casing of
	CONSTANT_POOL_ADDRESS_P SYMBOL_REFs.  If for MEM recursive call
	on MEM's address failed, try avoid_constant_pool_reference and
	recurse if it returned something different.
	(loc_descriptor): If for MEM mem_loc_descriptor failed on the
	address, try avoid_constant_pool_reference and recurse if it
	returned something different.
	(dw_loc_list_1): If for MEM mem_loc_descriptor failed on the
	address and avoid_constant_pool_reference returned something
	different, don't set have_address.

2010-01-27  Alexandre Oliva  <aoliva@redhat.com>

	PR debug/42861
	* var-tracking.c (val_store): Add modified argument, obey it.
	Adjust callers.
	(count_uses): Move down logging of main.
	(compute_bb_dataflow): Use val_store for MO_VAL_USEs that
	don't need resolution.
	(emit_notes_in_bb): Likewise.

2010-01-27  Richard Guenther  <rguenther@suse.de>

	PR middle-end/42878
	* tree-inline.c (remap_decl): Delay remapping of SSA name
	default definitions until we need them.

2010-01-27  Jakub Jelinek  <jakub@redhat.com>

	* config/rs6000/rs6000.c (TARGET_DELEGITIMIZE_ADDRESS): Redefine.
	(rs6000_delegitimize_address): New function.

	* config/s390/s390.c (s390_delegitimize_address): Call
	delegitimize_mem_from_attrs.

	PR middle-end/42874
	* tree-inline.c (cannot_copy_type_1): Removed.
	(copy_forbidden): Don't forbid copying of functions containing
	records/unions with variable length fields.

2010-01-27  Christian Bruel  <christian.bruel@st.com>

	Revert:
	PR target/42841
	* config/sh/sh.c (find_barrier): Increase length for non delayed
	conditional branches.

2010-01-27  Matthias Klose  <doko@ubuntu.com>

	* configure.ac (gnu-unique-object): Fix ldd version check.
	* configure: Regenerate.

2010-01-26  Rainer Orth  <ro@CeBiTec.Uni-Bielefeld.DE>

	* config/sparc/sparc.c (sparc_elf_asm_named_section): Test for
	HAVE_GNU_AS value.
	* config/sparc/sysv4.h [HAVE_GNU_AS] (TARGET_ASM_NAMED_SECTION):
	Test for HAVE_GNU_AS value.

2010-01-26  Rainer Orth  <ro@CeBiTec.Uni-Bielefeld.DE>

	* config.gcc (mips-sgi-irix[56]*): Set use_gcc_stdint.
	* config/mips/iris.h (INT8_TYPE, INT16_TYPE, INT32_TYPE,
	INT64_TYPE): Define.
	(UINT8_TYPE, UINT16_TYPE, UINT32_TYPE, UINT64_TYPE): Define.
	(INT_LEAST8_TYPE, INT_LEAST16_TYPE, INT_LEAST32_TYPE,
	INT_LEAST64_TYPE): Define.
	(UINT_LEAST8_TYPE, UINT_LEAST16_TYPE, UINT_LEAST32_TYPE,
	UINT_LEAST64_TYPE): Define.
	(INT_FAST8_TYPE, INT_FAST16_TYPE, INT_FAST32_TYPE)
	INT_FAST64_TYPE): Define.
	(UINT_FAST8_TYPE, UINT_FAST16_TYPE, UINT_FAST32_TYPE,
	UINT_FAST64_TYPE): Define.
	(INTMAX_TYPE, UINTMAX_TYPE): Define.
	(INTPTR_TYPE, UINTPTR_TYPE): Define.
	(SIG_ATOMIC_TYPE): Define.

2010-01-26  Richard Guenther  <rguenther@suse.de>

	* df-scan.c (df_scan_set_bb_info): Remove assert.
	(df_insn_rescan_debug_internal): Merge asserts.
	(df_install_ref): Likewise.
	(df_mark_reg): Use bitmap_set_range.
	(df_hard_reg_used_p): Remove assert.
	(df_hard_reg_used_count): Likewise.

2010-01-26  Richard Guenther  <rguenther@suse.de>

	PR rtl-optimization/42685
	* web.c (web_main): Ignore DEBUG_INSNs.

2010-01-26  Joern Rennecke  <amylaar@spamcop.net>

	* doc/tm.texi (TARGET_HANDLE_C_OPTION): Explain arguments.

	(TARGET_RESOLVE_OVERLOADED_BUILTIN): Add loc parameter.
	Fix types of fndecl and arglist parameters.

2010-01-26  Richard Guenther  <rguenther@suse.de>

	PR middle-end/42806
	* tree-eh.c (unsplit_eh): Skip debug insns.

2010-01-26  Richard Guenther  <rguenther@suse.de>

	PR tree-optimization/42250
	* ipa-type-escape.c (type_escape_execute): Do not analyze clones.

2010-01-26  Jakub Jelinek  <jakub@redhat.com>

	PR fortran/42866
	* omp-low.c (expand_omp_sections): Only use single_pred if
	l2_bb is single_pred_p.

2010-01-25  Christian Bruel  <christian.bruel@st.com>

	PR target/42841
	* config/sh/sh.c (find_barrier): Increase length for non delayed
	conditional branches.
	(sh_insn_length_adjustment): Use JUMP_TABLE_DATA_P.

2010-01-24  David S. Miller  <davem@davemloft.net>

	* config/sparc/sysv4.h (TARGET_ASM_NAMED_SECTION): Only
	define if not using GAS.
	* config/sparc/sparc.c (sparc_elf_asm_named_section):
	Likewise.  Delete SECTION_MERGE code, which is only applicable
	when using GAS.

2010-01-24  Mark Mitchell  <mark@codesourcery.com>

	PR c++/42748
	* config/arm/arm.c (arm_mangle_type): Do not warn about changes to
	mangling of va_list in system headers.

2010-01-23  Toon Moene  <toon@moene.org>

	* tree-predcom.c (combine_chains): Return NULL, not false.

2010-01-23  Joern Rennecke  <amylaar@spamcop.net>

	* tree-loop-distribution.c (distribute_loop): Fix declaration and
	initialization of variable res to agree with return type.

2010-01-22  Steve Ellcey  <sje@cup.hp.com>

	* Makefile.in (tree-sra.o): Add $(EXPR_H) dependency.
	* tree-sra.c: Add include of expr.h.

2010-01-22  Jakub Jelinek  <jakub@redhat.com>

	* tree-into-ssa.c (maybe_register_def): If stmt ends the bb,
	insert the debug stmt on the single non-EH edge from the stmt.

2010-01-22  Richard Henderson  <rth@redhat.com>

	PR tree-opt/42833
	* tree-sra.c (sra_modify_assign): Delay re-gimplification of
	the RHS until after generate_subtree_copies has insertted its
	code before the current statement.

2010-01-22  Joern Rennecke  <amylaar@spamcop.net>

	* doc/tm.texi (TARGET_MIN_DIVISIONS_FOR_RECIP_MUL): Fix return type.

	* gcc-plugin.h (plugin_init): Use "C" likage for c++.

2010-01-21  Martin Jambor  <mjambor@suse.cz>

	PR tree-optimization/42585
	* tree-sra.c (struct access): New field grp_total_scalarization.
	(dump_access): Dump the new field.
	(should_scalarize_away_bitmap): New variable.
	(cannot_scalarize_away_bitmap): Likewise.
	(sra_initialize): Allocate new bitmaps.
	(sra_deinitialize): Free new bitmaps.
	(create_access_1): New function.
	(create_access): Parts moved to create_access_1.
	(type_consists_of_records_p): New function.
	(completely_scalarize_record): Likewise.
	(build_access_from_expr): Set bit in cannot_scalarize_away_bitmap.
	(build_accesses_from_assign): Set bits in should_scalarize_away_bitmap.
	(sort_and_splice_var_accesses): Hint groups with a total_scalarization
	access.
	(analyze_all_variable_accesses): Completely scalarize small eligible
	records.

2010-01-21  Martin Jambor  <mjambor@suse.cz>

	* tree-sra.c (build_ref_for_offset_1): Allow for zero size fields.

2010-01-21  Andrew Haley  <aph@redhat.com>

	* gcc.c (process_command): Move lang_specific_driver before
	setting cc_libexec_prefix.

2010-01-21  Richard Guenther  <rguenther@suse.de>

	PR middle-end/19988
	* fold-const.c (negate_expr_p): Pretend only negative
	real constants are easily negatable.

2010-01-20  Janis Johnson  <janis187@us.ibm.com>
	    Jason Merrill  <jason@redhat.com>

	* tree.h (TYPE_TRANSPARENT_UNION): Replace with ...
	(TYPE_TRANSPARENT_AGGR): this, for union and record.
	* calls.c (initialize argument_information): Handle it.
	* c-common.c (handle_transparent_union_attribute): Use new name.
	* c-decl.c (finish_struct): Ditto.
	* c-typeck.c (type_lists_compatible_p): Ditto.
	(convert_for_assignment): Use new name and also handle record.
	* function.c (aggregate_value_p): Handle it.
	(pass_by_reference): Ditto.
	(assign_parm_data_types): Ditto.
	* print-tree.c (print_node): Ditto.
	* lto-streamer-in.c (unpack_ts_type_value_fields): Ditto.
	* lto-streamer-out.c (pack_ts_type_value_fields): Ditto.
	* tree.c (first_field): New fn.

2010-01-21  Dave Korn  <dave.korn.cygwin@gmail.com>

	PR target/42818
	* config/i386/cygwin.h (CXX_WRAP_SPEC_LIST): Always apply wrappers,
	even when linking statically, for now.

2010-01-20  Alexandre Oliva  <aoliva@redhat.com>

	PR debug/42715
	* var-tracking.c (use_type): Choose MO_VAL_SET for REGs set
	without a cselib val.
	(count_uses): Accept MO_VAL_SET with no val on stores.
	(add_stores): Likewise.

2010-01-20  Jakub Jelinek  <jakub@redhat.com>

	* var-tracking.c (check_value_val): Add a compile time assertion.
	(dv_is_decl_p): Simplify.
	(dv_as_decl, dv_as_value, dv_from_decl, dv_from_value): Only use
	gcc_assert if ENABLE_CHECKING.

2010-01-20  Alexandre Oliva  <aoliva@redhat.com>

	PR debug/42782
	* var-tracking.c: Include tree-flow.h.
	(mem_dies_at_call): New.
	(dataflow_set_preserve_mem_locs): Use it.
	(dataflow_set_remove_mem_locs): Likewise.
	(dump_var): Renamed from dump_variable.  Adjust all callers.
	(dump_var_slot): Renamed from dump_variable_slot.  Likewise.
	* Makefile.in (var-tracking.o): Adjust deps.

2010-01-20  Joern Rennecke  <amylaar@spamcop.net>

	* doc/tm.texi (TARGET_SCHED_SET_SCHED_FLAGS): Fix argument list.

2010-01-20  Richard Guenther  <rguenther@suse.de>

	PR tree-optimization/42717
	* tree-ssa-dce.c (get_live_post_dom): Remove.
	(forward_edge_to_pdom): Take an arbitrary edge to copy
	degenerate PHI args from.
	(remove_dead_stmt): Use the first post-dominator even if it
	does not contain live statements as redirection destination.

2010-01-20  Richard Guenther  <rguenther@suse.de>

	* tree-inline.c (estimate_num_insns): Handle EH builtins.

2010-01-20  Jakub Jelinek  <jakub@redhat.com>

	* sel-sched.c (create_speculation_check): Remove set but not used
	variable twin.
	(try_transformation_cache): Remove set but not used variable ds.
	(calculate_privileged_insns): Remove set but not used variables
	cur_insn and min_spec_insn.
	(find_best_expr): Remove set but not used variable avail_n.
	* tree-predcom.c (base_names_in_chain_on): Remove set but not used
	variable e.
	* cgraphunit.c (assemble_thunk): Remove set but not used variable
	false_label.
	* haifa-sched.c (remove_notes): Remove set but not used variable prev.
	* graphite-clast-to-gimple.c (gloog): Remove set but not used variable
	new_scop_exit_edge.

2010-01-20  Felyza Wishbringer  <fwishbringer@gmail.com>

	PR bootstrap/42786
	* config.gcc (i[34567]86-*-*): Fix handling of athlon64 and athlon-fx
	cpu types.  Add support for *-sse3 cpu types.
	(x86_64-*-*): Ditto.

2010-01-20  Jakub Jelinek  <jakub@redhat.com>

	PR middle-end/42803
	* varasm.c (narrowing_initializer_constant_valid_p): Add CACHE
	argument, call initializer_constant_valid_p_1 instead of
	initializer_constant_valid_p, pass CACHE to it, return NULL
	immediately if first call returns NULL.
	(initializer_constant_valid_p_1): New function.
	(initializer_constant_valid_p): Use it.

2010-01-20  Thomas Quinot  <quinot@adacore.com>

	* tree.def (PLACEHOLDER_EXPR): Fix comment.

2010-01-20  Jakub Jelinek  <jakub@redhat.com>

	* dwarf2out.c (mem_loc_descriptor): Use DW_OP_mod for UMOD instead
	of MOD, handle MOD using DW_OP_{over,over,div,mul,minus}.
	(loc_list_from_tree): Don't handle unsigned division.  Handle
	signed modulo using DW_OP_{over,over,div,mul,minus}.
	* unwind-dw2.c (execute_stack_op): Handle DW_OP_mod using unsigned
	modulo instead of signed.

2010-01-20  DJ Delorie  <dj@redhat.com>

	* config/h8300/h8300.c (F): Add "in_epilogue" flag.
	(Fpa): Pass it
	(h8300_emit_stack_adjustment): Propogate it.
	(push): Pass it.
	(h8300_expand_prologue): Likewise.
	(h8300_expand_epilogue): Likewise.

2010-01-19  Michael Matz  <matz@suse.de>

	PR tree-optimization/41783
	* tree-data-ref.c (toplevel): Include flags.h.
	(dump_data_dependence_relation):  Also dump the inputs if the
	result will be unknown.
	(split_constant_offset_1): Look through some conversions.
	* tree-predcom.c (determine_roots_comp): Restart a new chain if
	the offset from last element is too large.
	(ref_at_iteration): Deal also with MISALIGNED_INDIRECT_REF.
	(reassociate_to_the_same_stmt): Handle vector registers.
	* tree-vect-data-refs.c (vect_equal_offsets): Handle unary operations
	(e.g. conversions).
	* tree-vect-loop-manip.c (vect_gen_niters_for_prolog_loop): Add
	wide_prolog_niters argument, emit widening instructions.
	(vect_do_peeling_for_alignment): Adjust caller, use widened
	variant of the iteration cound.
	* Makefile.in (tree-data-ref.o): Add $(FLAGS_H).

2010-01-19  Ramana Radhakrishnan  <ramana.radhakrishnan@arm.com>

	PR target/38697
	* config/arm/neon-testgen.m (emit_automatics): New parameter
	features. Adjust for Fixed_return_reg feature.
	(test_intrinsic): Call emit_automatics with new feature.
	* config/arm/neon.ml: Update copyright years.
	(features): New Fixed_return_reg feature.
	(ops): Update feature for Vget_low.

2010-01-19  Jakub Jelinek  <jakub@redhat.com>

	PR tree-optimization/42719
	* tree-outof-ssa.c (trivially_conflicts_p): Don't consider debug
	stmt uses.

	PR debug/42728
	* fwprop.c (all_uses_available_at): Return false if def_set dest
	is a REG that is used in def_insn.

2010-01-19  Joern Rennecke  <amylaar@spamcop.net>

	* doc/tm.texi (TARGET_FIXED_CONDITION_CODE_REGS): Add argument names.

	(TARGET_CC_MODES_COMPATIBLE): Put return value in braces.
	Add argument names.

	(TARGET_SCHED_INIT_SCHED_CONTEXT): Clarify language.

	* target.h (struct gcc_target) <secondary_reload>: Change type
	of last argument to secondary_reload_info *.

2010-01-18  Uros Bizjak  <ubizjak@gmail.com>

	PR target/42774
	* config/alpha/predicates.md (aligned_memory_operand): Return 0 for
	memory references with unaligned offsets.  Remove CQImode handling.
	(unaligned_memory_operand): Return 1 for memory references with
	unaligned offsets.  Remove CQImode handling.

2010-01-18  Richard Guenther  <rguenther@suse.de>

	PR middle-end/39954
	* cfgexpand.c (expand_call_stmt): TER pointer arguments in
	builtin calls.

2010-01-18  Richard Guenther  <rguenther@suse.de>

	PR tree-optimization/42781
	* tree-ssa-structalias.c (find_what_var_points_to): Skip
	restrict processing only if the original variable was
	artificial.

2010-01-18  Joern Rennecke  <amylaar@spamcop.net>

	* doc/tm.texi (TARGET_ASM_FUNCTION_EPILOGUE): Update text on where to
	find number of popped argument bytes.

	(TARGET_INVALID_WITHIN_DOLOOP): Put return value in braces.
	Fix the text that describes the return value for invalid insns.

	(TARGET_SCHED_NEEDS_BLOCK_P): Fix return type.  Fix argument list.

	(TARGET_SCHED_IS_COSTLY_DEPENDENCE): Fix argument types.
	Clarify what 'cost of the -dependence' is.  Fix quoting.

	* toplev.c (default_get_pch_validity): Rename argument to "sz".
	* doc/tm.texi (TARGET_GET_PCH_VALIDITY): Likewise.

2010-01-17  Jakub Jelinek  <jakub@redhat.com>

	* dwarf2out.c (mem_loc_descriptor): Don't ICE on
	{S,U}S_{PLUS,MINUS,NEG,ABS,ASHIFT}.

2010-01-17  Richard Guenther  <rguenther@suse.de>

	PR middle-end/42248
	* function.c (split_complex_args): Take a VEC to modify.
	(assign_parms_augmented_arg_list): Build a VEC instead of
	a chain of PARM_DECLs.
	(assign_parms_unsplit_complex): Take a VEC of arguments.
	Do not fixup unmodified parms.
	(assign_parms): Deal with the VEC.
	(gimplify_parameters): Likewise.

2010-01-17  Richard Guenther  <rguenther@suse.de>

	* tree-ssa-uncprop.c (uncprop_into_successor_phis): Fix PHI
	node existence check.
	* tree-vect-loop.c (vect_analyze_loop_form): Likewise.
	* tree-cfgcleanup.c (merge_phi_nodes): Likewise.
	* tree-ssa-dce.c (forward_edge_to_pdom): Likewise.
	* tree-cfg.c (gimple_execute_on_growing_pred): Likewise.
	(gimple_execute_on_growing_pred): Likewise.

2010-01-17  Richard Guenther  <rguenther@suse.de>

	PR tree-optimization/42773
	* tree-ssa-pre.c (phi_translate_set): Fix check for PHI node existence.
	(compute_antic_aux): Likewise.
	(compute_partial_antic_aux): Likewise.

2010-01-17  Jie Zhang  <jie.zhang@analog.com>

	PR debug/42767
	* dwarf2out.c (mem_loc_descriptor): Handle SS_TRUNCATE
	and US_TRUNCATE.

2010-01-17  Joern Rennecke  <amylaar@spamcop.net>

	* doc/tm.texi (TARGET_INIT_LIBFUNCS): Put @findex entries in order of
	appearance.

	(TARGET_LEGITIMATE_ADDRESS_P): Add return type.
	Fix markup for strict argument.

	(TARGET_SCHED_REORDER2): Fix argument types.

	(TARGET_SCHED_DFA_PRE_CYCLE_INSN): Fix return type.
	(TARGET_SCHED_DFA_POST_CYCLE_INSN): Likewise.

	(TARGET_SCHED_DFA_PRE_ADVANCE_CYCLE): Fix name.
	(TARGET_SCHED_DFA_POST_ADVANCE_CYCLE): Likewise.

	(TARGET_SCHED_FIRST_CYCLE_MULTIPASS_DFA_LOOKAHEAD_GUARD):
	Add argument name.

	(TARGET_SCHED_ALLOC_SCHED_CONTEXT): Remove duplicate documentation.
	(TARGET_SCHED_INIT_SCHED_CONTEXT): Likewise.
	(TARGET_SCHED_SET_SCHED_CONTEXT): Likewise.
	(TARGET_SCHED_CLEAR_SCHED_CONTEXT): Likewise.
	(TARGET_SCHED_FREE_SCHED_CONTEXT): Likewise.

	(TARGET_SCHED_SET_SCHED_CONTEXT): Fix typo.

	(TARGET_SCHED_GEN_SPEC_CHECK): Fix name.

	(TARGET_ASM_RELOC_RW_MASK): Add return type.
	(TARGET_MANGLE_DECL_ASSEMBLER_NAME): Fix return type.

	(TARGET_STRIP_NAME_ENCODING): Fix markup of return type and parameter.

	(TARGET_ASM_FILE_START): Put @findex before paragraph start.
	Use prototype.

	(TARGET_ASM_NAMED_SECTION): Fix argument list.

	(TARGET_HAVE_NAMED_SECTIONS): Use @deftypevr.
	(TARGET_HAVE_SWITCHABLE_BSS_SECTIONS): Likewise.

	(TARGET_ASM_RECORD_GCC_SWITCHES_SECTION): Use @deftypevr.

	(TARGET_ASM_ASSEMBLE_VISIBILITY): Fix argument types.

	(TARGET_ASM_MARK_DECL_PRESERVED): Fix argument and markup
	referring to it.  Fix language.

	(TARGET_HAVE_CTORS_DTORS): Use @deftypevr.

	(TARGET_ASM_FINAL_POSTSCAN_INSN): Adjust name of first argument.

	(TARGET_ASM_EMIT_UNWIND_LABEL): Add argument types.

	(TARGET_ASM_EMIT_EXCEPT_TABLE_LABEL): Add type to argument.

	(TARGET_UNWIND_EMIT): Remove space between 'FILE *' and
	'@var{stream}.  Remove stray 'and'.

	(TARGET_ARM_EABI_UNWINDER): Use @deftypevr.

	(TARGET_ASM_OUTPUT_DWARF_DTPREL): Adjust name of first argument.

	(TARGET_SET_DEFAULT_TYPE_ATTRIBUTES): Add missing article.

	(TARGET_OPTION_VALID_ATTRIBUTE_P): Fix name, it was
	misspelled as TARGET_VALID_OPTION_ATTRIBUTE_P.

	(TARGET_GET_PCH_VALIDITY): Put 'void *' in braces.
	Fix description of return value.
	Rename argument "sz" to "len."

	(TARGET_CXX_GUARD_MASK_BIT): Add missing article.
	Clarify meaning of 'true' return value.

	(TARGET_SHIFT_TRUNCATION_MASK): Fix return type.

	(TARGET_MODE_REP_EXTENDED): Fix two inconsisent uses of
	rep_mode versus mode_rep.

	(TARGET_HANDLE_PRAGMA_EXTERN_PREFIX): Document.

	(TARGET_BUILTIN_DECL): Fix name.

	(TARGET_COMMUTATIVE_P): Fix type of first argument.

	(TARGET_SET_CURRENT_FUNCTION): Mention possibility of cfun being NULL.

	(TARGET_BRANCH_TARGET_REGISTER_CLASS): Fix return type.

	(TARGET_USE_LOCAL_THUNK_ALIAS_P): Document as macro instead of hook.

	(TARGET_RELAXED_ORDERING): Use @deftypevr.

	(TARGET_GET_DRAP_RTX): Note that this is a hook.
	Clarify language.

	(TARGET_BUILTIN_RECIPROCAL): Fix argument types.
	Rename argument tm_fn to md_fn.

	(TARGET_OPTION_PRINT): Fix argument list.

2010-01-16  Harsha Jagasia  <harsha.jagasia@amd.com>

	PR target/42664
	* config/i386/i386.c (ix86_fixup_binary_operands):
	Revert FMA4 fixup of operands.

2010-01-16  Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>

	PR gcc/42525
	* Makefile.in (write_entries_to_file, install-plugin):
	Use \012 instead of \n with tr.

2010-01-16  Richard Sandiford  <r.sandiford@uk.ibm.com>

	* configure.ac (HAVE_AS_REF): New C macro.
	* configure: Regenerate.
	* config.in: Likewise.
	* collect2.c (main): Only postpone SCAN_DWEH to the second pass
	if HAVE_AS_REF.
	* config/rs6000/aix.h (ASM_OUTPUT_DWARF_TABLE_REF): Only define
	if HAVE_AS_REF.

2010-01-16  Joern Rennecke  <amylaar@spamcop.net>

	* doc/tm.texi (TARGET_USE_BLOCKS_FOR_CONSTANT_P): Fix argument types.

	(TARGET_SUPPORT_VECTOR_MISALIGNMENT): Fix argument types.

	(TARGET_USE_ANCHORS_FOR_SYMBOL_P): Fix argument types.

	(TARGET_SCHED_ALLOC_SCHED_CONTEXT): Put 'void *' in braces.

	(TARGET_IN_SMALL_DATA_P): Fix argument type.

	(TARGET_BINDS_LOCAL_P): Fix argument type.

	(TARGET_ASM_FILE_END): Use prototype.

	(TARGET_ASM_RECORD_GCC_SWITCHES): Don't put 'int' in braces.

	(TARGET_DWARF_CALLING_CONVENTION): Fix argument type.

	(TARGET_COMP_TYPE_ATTRIBUTES): Fix argument types.

	(TARGET_VALID_DLLIMPORT_ATTRIBUTE_P): Fix argument type.

	(TARGET_EMUTLS_VAR_ALIGN_FIXED): Don't put 'bool' in braces.
	(TARGET_EMUTLS_DEBUG_FORM_TLS_ADDRESS): Likewise.

	(TARGET_PCH_VALID_P): Put 'const char *' in braces.
	(TARGET_CHECK_PCH_TARGET_FLAGS): Likewise.

	(TARGET_ADDR_SPACE_LEGITIMATE_ADDRESS_P): Don't put 'bool' in braces.
	(TARGET_ADDR_SPACE_SUBSET_P): Likewise.
	(TARGET_ADDR_SPACE_LEGITIMIZE_ADDRESS): Don't put 'rtx' in braces.
	(TARGET_ADDR_SPACE_CONVERT): Likewise.

	(TARGET_CASE_VALUES_THRESHOLD): Put 'unsigned int' in braces.

	(TARGET_MACHINE_DEPENDENT_REORG: Use prototype.

	(TARGET_INIT_BUILTINS): Use prototype.

	(TARGET_INVALID_ARG_FOR_UNPROTOTYPED_FN):
	Put 'const char *' in braces.  Fix parameter types.
	(TARGET_INVALID_CONVERSION): Fix parameter types.
	(TARGET_INVALID_UNARY_OP, TARGET_INVALID_BINARY_OP): Likewise.
	(TARGET_INVALID_PARAMETER_TYPE, TARGET_INVALID_RETURN_TYPE): Likewise.

	(TARGET_PROMOTED_TYPE): Remove braces around 'tree'.
	Fix argument type.

	(TARGET_CONVERT_TO_TYPE): Remove braces around 'tree'.

	(TARGET_ALLOCATE_STACK_SLOTS_FOR_ARGS): Remove braces around 'bool'.

2010-01-15  Joern Rennecke  <amylaar@spamcop.net>

	* doc/tm.texi (TARGET_HELP): Fix return type.

	(TARGET_PROMOTE_FUNCTION_MODE): Put 'enum machine_mode'
	in braces.  Fix argument types.

	(TARGET_LIBGCC_CMP_RETURN_MODE): Use prototype.

	(TARGET_LIBGCC_SHIFT_COUNT_MODE): Use prototype.

	(TARGET_MS_BITFIELD_LAYOUT_P): Fix argument type.

	(TARGET_DECIMAL_FLOAT_SUPPORTED_P): Don't put 'bool' in braces.
	(TARGET_FIXED_POINT_SUPPORTED_P): Likewise.

	(TARGET_MANGLE_TYPE): Fix argument types.

	(TARGET_IRA_COVER_CLASSES): Use prototype.

	(TARGET_BUILTIN_SETJMP_FRAME_VALUE): Fix return type.  Use prototype.

	(TARGET_CAN_ELIMINATE): Use identifiers for argument names.

	(TARGET_PROMOTE_PROTOTYPES): Fix argument type.

	(TARGET_MUST_PASS_IN_STACK): Fix argument type.

	(TARGET_CALLEE_COPIES): Fix argument types.

	(TARGET_SPLIT_COMPLEX_ARG): Fix argument type.

	(TARGET_GIMPLIFY_VA_ARG_EXPR): Fix argument types.

	(TARGET_FUNCTION_VALUE): Fix argument types.

	(TARGET_RETURN_IN_MSB): Fix argument type.

	(TARGET_RETURN_IN_MEMORY): Fix argument types.

	(TARGET_ASM_CAN_OUTPUT_MI_THUNK): Fix argument types.

	(TARGET_EXTRA_LIVE_ON_ENTRY): Fix argument type.

	(TARGET_STRICT_ARGUMENT_NAMING): Make literal in text
	agree with return type.

	(TARGET_PRETEND_OUTGOING_VARARGS_NAMED): Add Prototype.

2010-01-15  Jing Yu  <jingyu@google.com>

	PR rtl-optimization/42691
	* combine.c (try_combine): Set changed_i3_dest to 1 when I2 and I3 set
	a pseudo to a constant and are merged, and adjust comments.

2010-01-15  Eric Botcazou  <ebotcazou@adacore.com>

	* config/i386/sse.md (avx_vperm2f128<mode>3): Fix typo.

2010-01-15  Richard Guenther  <rguenther@suse.de>

	PR middle-end/42739
	* tree-cfgcleanup.c (remove_forwarder_block): Move destination
	labels of computed or non-local gotos to the destination.
	* tree-cfg.c (gimple_verify_flow_info): Verify that a EH
	landing pad label is the first label.

2010-01-15  Richard Guenther  <rguenther@suse.de>

	* tree-ssa-loop-im.c (gen_lsm_tmp_name): Fix bogus fallthru.

2010-01-14  Michael Meissner  <meissner@linux.vnet.ibm.com>

	PR target/42747
	* config/rs6000/rs6000.md (sqrtdf2): Split into expander and insn
	to allow generation of the xssqrtdp instruction on power7.
	(sqrtdf2_fpr): Ditto.

2010-01-14  Jakub Jelinek  <jakub@redhat.com>

	PR middle-end/42674
	* c-decl.c (finish_function): Don't emit -Wreturn-type warnings in
	functions with noreturn attribute.

	PR c++/42608
	* varasm.c (declare_weak): Add weak attribute to decl if it
	doesn't have one already.
	(assemble_external): Only add decls to weak_decls if they also
	have weak attribute.

2010-01-14  Alexandre Oliva  <aoliva@redhat.com>

	* var-tracking.c (var_reg_delete): Don't delete the association
	between REGs and values or one-part variables if the register
	isn't clobbered.

2010-01-14  Jakub Jelinek  <jakub@redhat.com>

	PR debug/42657
	* tree-inline.c (copy_debug_stmt): Don't reset debug stmt just
	because its first operand is a non-localized variable.

2010-01-14  Martin Jambor  <mjambor@suse.cz>

	PR tree-optimization/42706
	* tree-sra.c (encountered_recursive_call): New variable.
	(encountered_unchangable_recursive_call): Likewise.
	(sra_initialize): Initialize both new variables.
	(callsite_has_enough_arguments_p): New function.
	(scan_function): Call decl and flags check only for IPA-SRA, check
	whether there is a recursive call and whether it has enough arguments.
	(all_callers_have_enough_arguments_p): New function.
	(convert_callers): Look for recursive calls only when
	encountered_recursive_call is set.
	(ipa_early_sra): Bail out either if
	!all_callers_have_enough_arguments_p or
	encountered_unchangable_recursive_call.

2010-01-14  Alexander Monakov  <amonakov@ispras.ru>

	* sel-sched.c: Add 2010 to copyright years.
	* sel-sched-ir.c: Likewise.
	* sel-sched-ir.h: Likewise.

2010-01-14  Martin Jambor  <mjambor@suse.cz>

	PR tree-optimization/42714
	* tree-sra.c (sra_ipa_modify_assign): Handle incompatible-type
	constructors specially.

2010-01-14  Andi Kleen  <ak@linux.intel.com>

	* config/i386/drivers-i386.c (detect_caches_intel):
	Add l2sizekb parameter and fill in.
	(host_detect_local_cpu): Add l2sizekb, fill in.
	Add Atom small cache heuristic.

2010-01-14  Andi Kleen  <ak@linux.intel.com>

	* config/i386/drivers-i386.c (detect_caches_cpuid4):
	Add level3 parameter and fill in.
	(detect_caches_intel): Handle level3 cache.

2010-01-14  Andi Kleen  <ak@linux.intel.com>

	* config/i386/drivers-i386.c (host_detect_local_cpu):
	Fix core duo detection.

2010-01-14  Andi Kleen  <ak@linux.intel.com>

	* config/i386/drivers-i386.c (host_detect_local_cpu):
	Fix Atom detection.

2010-01-14  Alexander Monakov  <amonakov@ispras.ru>

	* config/rs6000/rs6000.c (rs6000_variable_issue): Rename to...
	(rs6000_variable_issue_1): this.  Use...
	(rs6000_variable_issue): here.  Reimplement.  Print debug info.

2010-01-14  Alexander Monakov  <amonakov@ispras.ru>

	* sel-sched-ir.c (sel_restore_other_notes): Rename to
	sel_restore_notes.  Update all callers.  Call reemit_notes
	for all insns.

2010-01-14  Andrey Belevantsev  <abel@ispras.ru>

	PR rtl-optimization/42246
	* sel-sched-ir.h (get_all_loop_exits): Include exits from inner
	loops.

2010-01-14  Andrey Belevantsev  <abel@ispras.ru>

	* sel-sched.c (compute_av_set_at_bb_end): Do not test that number of
	all successors is the same as number of successors in current region.

2010-01-14  Alexander Monakov  <amonakov@ispras.ru>

	* sel-sched.c (maybe_emit_renaming_copy): Exit early when expression
	to rename is not separable.  Otherwise check that its LHS is not NULL.

2010-01-14  Alexander Monakov  <amonakov@ispras.ru>

	* sel-sched.c (choose_best_reg_1):  Loop over all regs for mode.

2010-01-14  Alexander Monakov  <amonakov@ispras.ru>

	* sel-sched.c (mark_unavailable_hard_regs): Do not try to search
	available registers when failed to discover LHS register class.
	Fix indentation.  Update comment.

2010-01-14  Andrey Belevantsev  <abel@ispras.ru>
	    Alexander Monakov  <amonakov@ispras.ru>

	PR rtl-optimization/42389
	* sel-sched.c (advance_one_cycle): Set FENCE_ISSUE_MORE
	to can_issue_more.
	(advance_state_on_fence): Likewise.
	(sel_target_adjust_priority): Print debug output only when
	sched_verbose >= 4, not 2.
	(get_expr_cost): Do not issue all unique insns on the next cycle.
	(fill_insns): Initialize can_issue_more from the value saved
	with the fence.
	* sel-sched-ir.c (flist_add): New parameter issue_more.
	Init FENCE_ISSUE_MORE with it.
	(merge_fences): Likewise.
	(init_fences): Update call to flist_add.
	(add_to_fences, add_clean_fence_to_fences)
	(add_dirty_fence_to_fences): Likewise.
	(move_fence_to_fences): Update call to merge_fences.
	(invoke_reorder_hooks): Do not reset can_issue_more on insns from
	sched groups.
	* sel-sched-ir.h (struct _fence): New field issue_more.
	(FENCE_ISSUE_MORE): New accessor macro.

2010-01-14  Andrey Belevantsev  <abel@ispras.ru>

	PR rtl-optimization/42388
	* sel-sched-ir.c (maybe_tidy_empty_bb): Do not delete empty blocks
	that have no predecessors nor successors.  Do not call move_bb_info
	for empty blocks outside of current region.

2010-01-14  Alexander Monakov  <amonakov@ispras.ru>

	PR rtl-optimization/42294
	* sel-sched-ir.h (struct _sel_insn_data): Update comment.
	* sel-sched.c (move_exprs_to_boundary): Transitively add all
	originators' originators.

2010-01-14  Alexander Monakov  <amonakov@ispras.ru>

	PR rtl-optimization/39453
	PR rtl-optimization/42246
	* sel-sched-ir.c (considered_for_pipelining_p): Do not test
	for pipelining_p.
	(sel_add_loop_preheaders): Add preheader to last_added_blocks.

2010-01-14  Andrey Belevantsev  <abel@ispras.ru>
	    Alexander Monakov  <amonakov@ispras.ru>

	PR middle-end/42245
	* sel-sched-ir.c (sel_recompute_toporder): New.  Use it...
	(maybe_tidy_empty_bb): ... here.  Make static.  Add new
	argument.  Update all callers.
	(tidy_control_flow): ... and here.  Recompute topological order
	of basic blocks in region if necessary.
	(sel_redirect_edge_and_branch): Change return type.  Return true
	if topological order might have been invalidated.
	(purge_empty_blocks): Export and move from...
	* sel-sched.c (purge_empty_blocks): ... here.
	* sel-sched-ir.h (sel_redirect_edge_and_branch): Update prototype.
	(maybe_tidy_empty_bb): Delete prototype.
	(purge_empty_blocks): Declare.

2010-01-14  Andrey Belevantsev <abel@ispras.ru>

	PR rtl-optimization/42249
	* sel-sched.c (try_replace_dest_reg): When chosen register
	and original register is the same, do not bail out early, but
	still check all original insns for validity of replacing destination
	register.  Set EXPR_TARGET_AVAILABLE to 1 before leaving function
	in this case.

2010-01-14  Jakub Jelinek  <jakub@redhat.com>

	PR c/42721
	Port from no-undefined-overflow branch:
	2009-03-09  Richard Guenther  <rguenther@suse.de>

	* fold-const.c (add_double_with_sign): Fix unsigned overflow detection.

2010-01-14  Richard Guenther  <rguenther@suse.de>

	PR lto/42665
	* gimple.c (iterative_hash_gimple_type): Avoid hashing
	error_mark_node.

2010-01-14  Ira Rosen  <irar@il.ibm.com>

	PR tree-optimization/42709
	* tree-vect-slp.c (vect_get_constant_vectors): Use constant's type
	as scalar type in creation of constant vector operand.

2010-01-14  Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>

	PR testsuite/42414
	* Makefile.in ($(TESTSUITEDIR)/site.exp, check-%)
	(check-parallel-%): Match `testsuite' directory component only
	at the end.

2010-01-14  Shujing Zhao  <pearly.zhao@oracle.com>

	PR translation/39521
	* gcc.c (do_spec_1): Wrapped the error and notice messages of specs
	strings with _().

2010-01-13  Richard Guenther  <rguenther@suse.de>

	PR tree-optimization/42730
	* tree-ssa-ccp.c (maybe_fold_stmt_indirect): Add shortcut for
	offset zero.

2010-01-13  Steve Ellcey  <sje@cup.hp.com>

	PR target/pr42542
	* config/ia64/ia64.c (ia64_expand_vecint_compare): Convert GTU to GT
	for V2SI by subtracting (-(INT MAX) - 1) from both operands to make
	them signed.

2010-01-13  Bernd Schmidt  <bernd.schmidt@analog.com>

	* config/bfin/libgcc-bfin.ver: Regenerate based on current
	libgcc-std.ver.  Add entries for ___smulsi3_highpart and
	___umulsi3_highpart.

	* config/bfin/bfin.c (bfin_reorg): Call run_selective_scheduling
	rather than schedule_insns if the pass is enabled.

2010-01-13  Martin Jambor  <mjambor@suse.cz>

	PR tree-optimization/42704
	* tree-sra.c (sra_modify_assign): Do not delete assignments to
	SSA_NAMEs.

2010-01-13  Martin Jambor  <mjambor@suse.cz>

	PR tree-optimization/42703
	* tree-sra.c (analyze_access_subtree): Check that we can build a
	reference to the original data within the aggregate.

2010-01-13  Richard Guenther  <rguenther@suse.de>

	PR tree-optimization/42705
	* tree-ssa-reassoc.c (build_and_add_sum): Insert stmts after
	labels.

2010-01-13  Richard Guenther  <rguenther@suse.de>

	PR middle-end/42716
	* fold-const.c (fold_unary_loc): Fold INDIRECT_REFs.

2010-01-13  Jakub Jelinek  <jakub@redhat.com>

	PR debug/41371
	* var-tracking.c (values_to_unmark): New variable.
	(find_loc_in_1pdv): Clear VALUE_RECURSED_INTO of values in
	values_to_unmark vector.  Moved body to...
	(find_loc_in_1pdv_1): ... this.  Don't clear VALUE_RECURSED_INTO,
	instead queue it into values_to_unmark vector.
	(vt_find_locations): Free values_to_unmark vector.

2010-01-13  Wolfgang Gellerich  <gellerich@de.ibm.com>

	* config/s390/s390.c (override_options): Set
	default of max-pending-list-length to 256

2010-01-13  Richard Guenther  <rguenther@suse.de>

	PR lto/42678
	* tree-pass.h (PROP_gimple_lcx): New.
	* cfgexpand.c (pass_expand): Require PROP_gimple_lcx.
	* passes.c (init_optimization_passes): Move pass_lower_complex_O0
	before the final cleanup_eh.
	(dump_properties): Dump PROP_gimple_lcx.
	* tree-complex.c (pass_lower_complex): Provide PROP_gimple_lcx.
	(tree_lower_complex_O0): Remove.
	(gate_no_optimization): Run if PROP_gimple_lcx is not set.
	(pass_lower_complex_O0): Provide PROP_gimple_lcx.  Run
	tree_lower_complex, schedule TODO_update_ssa.
	* lto-streamer-out.c (output_function): Stream the functions
	properties.
	* lto-streamer-in.c (input_function): Likewise.
	(lto_read_body): Do not override them here.

2010-01-12  Joseph Myers  <joseph@codesourcery.com>

	PR c/42708
	* c-typeck.c (build_c_cast): Fold value cast to union type before
	wrapping it in a CONSTRUCTOR.

2010-01-12  Jakub Jelinek  <jakub@redhat.com>

	PR rtl-optimization/42699
	* cse.c (cse_insn): Optimize lhs ZERO_EXTRACT if only CONST_INTs are
	involved.

2010-01-12  Rainer Orth  <ro@CeBiTec.Uni-Bielefeld.DE>

	* config/mips/iris6.h (SUBTARGET_DONT_WARN_UNUSED_SPEC,
	SUBTARGET_WARN_UNUSED_SPEC): Move ...
	config/mips/iris.h (SUBTARGET_DONT_WARN_UNUSED_SPEC,
	SUBTARGET_WARN_UNUSED_SPEC): ... here
	* config/mips/iris5.h (LIBGCC_SPEC): Define.

2010-01-12  Julian Brown  <julian@codesourcery.com>

	* config/arm/neon-schedgen.ml (Utils): Don't try to
	open missing module.
	(find_with_result): New.

2010-01-12  Jakub Jelinek  <jakub@redhat.com>

	PR debug/42662
	* simplify-rtx.c (simplify_relational_operation_1): Avoid invalid rtx
	sharing when canonicalizing ({lt,ge}u (plus a b) b).

	PR tree-optimization/42645
	* tree-inline.c (processing_debug_stmt): Move earlier.  Make static.
	(remap_ssa_name): If processing_debug_stmt and name wasn't found in
	decl_map, set processing_debug_stmt to -1 and return name without
	any remapping.

2010-01-11  Dave Korn  <dave.korn.cygwin@gmail.com>

	* doc/install.texi (Specific#x-x-cygwin): Document minimum required
	binutils version, and reword target configuration description.

2010-01-11  Andy Hutchinson  <hutchinsonandy@gcc.gnu.org>

	* config/avr/avr.h (LINKER_NAME): Remove.

2010-01-11  Janis Johnson  <janis187@us.ibm.com>

	PR target/42416
	* config/rs6000/rs6000.c (rs6000_override_options): On targets
	that support VSX, warn for -mno-altivec if vsx is not disabled,
	and disable vsx.

2010-01-11  Joseph Myers  <joseph@codesourcery.com>
	    Shujing Zhao  <pearly.zhao@oracle.com>

	PR translation/42469
	* common.opt (Wframe-larger-than=, fcompare-debug=, fdbg-cnt=,
	fira-verbose=, flto-compression-level=, fplugin-arg-): Use tab
	character between option name and help text.
	* c.opt (imultilib): Likewise.

2010-01-10  Rafael Avila de Espindola  <espindola@google.com>

	* lto-streamer-out.c (output_unreferenced_globals): Output static
	variables.

2010-01-10  Steven Bosscher  <steven@gcc.gnu.org>

	PR rtl-optimization/42621
	* bb-reorder.c (gate_duplicated_computed_gotos): Only run if not
	optimizing for size.
	(duplicate_computed_gotos): Remove now-redundant check.

2010-01-10  Steve Ellcey  <sje@cup.hp.com>

	PR target/37454
	* configure.ac: Save and restore LDFLAGS and LIBS
	* configure: Regenerate.

2010-01-10  Richard Guenther  <rguenther@suse.de>

	PR middle-end/42667
	* builtins.c (fold_builtin_strlen): Add type argument and
	convert the resulting length to it.
	(fold_builtin_1): Adjust.

2010-01-09  Jakub Jelinek  <jakub@redhat.com>

	* config/rs6000/rs6000.c (rs6000_emit_set_long_const): Shorten
	sequence for DImode constants >= 0x80000000UL <= 0xFFFFFFFFUL by
	1 insn.
	(num_insns_constant_wide): Adjust for that change.

2010-01-09  Alexandre Oliva  <aoliva@redhat.com>

	PR debug/42631
	* web.c (union_defs): Add used argument, to combine uses of
	uninitialized regs.
	(entry_register): Adjust type and tests of used argument.
	(web_main): Widen used for new use.  Pass it to union_defs.
	* df.h (union_defs): Adjust prototype.

2010-01-09  Alexandre Oliva  <aoliva@redhat.com>

	PR debug/42630
	* loop-unroll.c (referenced_in_one_insn_in_loop_p): Count debug
	uses in new incoming argument.  Free body.
	(reset_debug_uses_in_loop): New.
	(analyze_insn_to_expand_var): Call the latter if the former found
	anything.  Fix whitespace.  Reject invalid dest overlaps before
	going through all insns in the loop.

2010-01-09  Alexandre Oliva  <aoliva@redhat.com>

	PR debug/42629
	* haifa-sched.c (dying_use_p): Debug insns don't count.

2010-01-09  Alexandre Oliva  <aoliva@redhat.com>

	PR middle-end/42363
	* gimplify.c (gimplify_modify_expr): Drop lhs on noreturn calls.
	* tree-cfg.c (is_ctrl_altering_stmt): Don't compute flags twice.
	(verify_gimple_call): Reject LHS in noreturn calls.

2010-01-09  Alexandre Oliva  <aoliva@redhat.com>

	PR debug/42604
	PR debug/42395
	* tree-vect-loop-manip.c (adjust_info): New type.
	(adjust_vec): New pointer to vector.
	(adjust_debug_stmts_now, adjust_vec_debug_stmts): New.
	(adjust_debug_stmts, adjust_phi_and_debug_stmts): New.
	(slpeel_update_phis_for_duplicate_loop): Use them.
	(slpeel_update_phi_nodes_for_guard1): Likewise.
	(slpeel_update_phi_nodes_for_guard2): Likewise.
	(slpeel_tree_peel_loop_to_edge): Likewise.
	(vect_update_ivs_after_vectorizer): Likewise.

2010-01-09  Alexandre Oliva  <aoliva@redhat.com>

	* vec.h (DEF_VEC_ALLOC_FUNC_O_STACK): Drop excess paren.
	(DEF_VEC_ALLOC_FUNC_I_STACK): Likewise.

2010-01-09  Alexandre Oliva  <aoliva@redhat.com>

	* config/i386/i386.c (ix86_vectorize_builtin_vec_perm): Silence
	bogus uninitialized warning.

2010-01-09  Richard Guenther  <rguenther@suse.de>

	PR middle-end/42512
	* tree-scalar-evolution.c (interpret_loop_phi): Make sure
	the evolution is compatible with the initial condition.

2010-01-09  Jakub Jelinek  <jakub@redhat.com>

	* gcc.c (process_command): Update copyright notice dates.
	* gcov.c (print_version): Likewise.
	* gcov-dump.c (print_version): Likewise.
	* mips-tfile.c (main): Likewise.
	* mips-tdump.c (main): Likewise.

2010-01-08  Andy Hutchinson  <hutchinsonandy@gcc.gnu.org>

	PR target/41885
	* config/avr/avr.md (rotlqi3): Add CONST_INT_P check.
	(rotlhi3): Delete.
	(rotlhi3_8): Delete.
	(rotlsi3): Delete.
	(rotlsi3_8): Delete.
	(rotlsi3_16): Delete.
	(rotlsi3_24): Delete.
	(rotl<mode>3): New.
	(*rotw<mode>3): New.
	(*rotb<mode>3): New.
	* config/avr/avr.c (avr_rotate_bytes): New function.
	* config/avr/avr-proto.h (avr_rotate_bytes): New function.

2010-01-08  Steve Ellcey  <sje@cup.hp.com>

	PR target/37454
	* configure.ac: Modify -rdynamic check.
	* configure: Regenerate.

2010-01-08  DJ Delorie  <dj@redhat.com>

	* config/sh/sh.c (sh_expand_epilogue): Fix interrupt handler
	register popping order.

2010-01-08  Richard Guenther  <rguenther@suse.de>

	PR lto/42528
	* c.opt (fsigned-char): Also let LTO handle this option.
	(funsigned-char): Likewise.

2010-01-07  Richard Guenther  <rguenther@suse.de>

	* gimple.h (gss_for_code): Wrap gcc_assert in ENABLE_CHECKING.
	(gimple_op): Likewise.
	(gimple_op_ptr): Likewise.
	(gimple_assign_set_lhs): Remove gcc_assert.
	(gimple_assign_set_rhs1): Likewise.
	(gimple_assign_set_rhs2): Likewise.
	(gimple_call_set_lhs): Likewise.
	(gimple_call_set_fn): Likewise.
	(gimple_call_set_fndecl): Likewise.
	(gimple_call_fndecl): Likewise.
	(gimple_call_return_type): Likewise.
	(gimple_call_set_chain): Likewise.
	(gimple_call_num_args): Likewise.
	(gimple_call_set_arg): Likewise.
	(gimple_cond_set_code): Likewise.
	(gimple_cond_set_lhs): Likewise.
	(gimple_cond_set_rhs): Likewise.
	(gimple_cond_set_true_label): Likewise.
	(gimple_cond_set_false_label): Likewise.
	(gimple_label_set_label): Likewise.
	(gimple_goto_set_dest): Likewise.
	(gimple_debug_bind_get_var): Wrap gcc_assert in ENABLE_CHECKING.
	(gimple_debug_bind_get_value): Likewise.
	(gimple_debug_bind_get_value_ptr): Likewise.
	(gimple_debug_bind_set_var): Likewise.
	(gimple_debug_bind_set_value): Likewise.
	(gimple_debug_bind_reset_value): Likewise.
	(gimple_debug_bind_has_value_p): Likewise.
	(gimple_return_retval_ptr): Remove gcc_assert.
	(gimple_return_retval): Likewise.
	(gimple_return_set_retval): Likewise.
	* tree-flow.h (struct gimple_df): Remove nonlocal_all member.
	(safe_referenced_var_iterator): Remove.
	(FOR_EACH_REFERENCED_VAR_SAFE): Likewise.
	* tree-flow-inline.h (gimple_nonlocal_all): Remove.
	(fill_referenced_var_vec): Remove.
	(first_readonly_imm_use): Remove redundant gcc_assert.
	(phi_arg_index_from_use): Combine gcc_asserts.
	(move_use_after_head): Wrap gcc_assert in ENABLE_CHECKING.
	(first_imm_use_stmt): Remove redundant gcc_assert.
	* tree-cfg.c (verify_gimple_call): Verify function and chain
	operands.  Verify arguments.
	(verify_types_in_gimple_stmt): Verify condition code and labels.

2010-01-07  Richard Guenther  <rguenther@suse.de>

	PR tree-optimization/42641
	* sese.c (rename_map_elt_info): Use the SSA name version, do
	not hash pointers.

2010-01-07  Jakub Jelinek  <jakub@redhat.com>

	PR tree-optimization/42625
	* cgraph.c (cgraph_make_node_local): Clear DECL_COMDAT*,
	TREE_PUBLIC, DECL_WEAK and DECL_EXTERNAL also for same_body
	aliases.

2010-01-07  Duncan Sands  <baldrick@free.fr>

	* Makefile.in (PLUGIN_HEADERS): Add version.h.

2010-01-07  Uros Bizjak  <ubizjak@gmail.com>

	PR target/42511
	* ifcvt.c (dead_or_predicable): Also remove REG_EQUAL note when
	note itself is not function_invariant_p.

2009-01-07  Steven Bosscher  <steven@gcc.gnu.org>

	* gcse.c (execute_rtl_cprop, execute_rtl_pre, execute_rtl_hoist):
	Do not add the DF_NOTE problem.
	* store-motion.c (execute_rtl_store_motion): Likewise.

2010-01-07  Martin Jambor  <mjambor@suse.cz>

	PR tree-optimization/42157
	* tree-sra.c (compare_access_positions): Stabilize sort if both
	accesses have integer types, return zero immediately if they are the
	same.

2010-01-06  Richard Henderson  <rth@redhat.com>

	PR middle-end/41883
	* haifa-sched.c (add_to_note_list): Merge into ...
	(concat_note_lists): ... here, and ...
	(unlink_other_notes, rm_other_notes): Merge into...
	(remove_notes): ... here.  Create REG_SAVE_NOTEs for
	NOTE_INSN_EPILOGUE_BEG.

2010-01-06  Richard Guenther  <rguenther@suse.de>

	* ipa-inline.c (cgraph_decide_inlining_incrementally): Do
	not inline regular functions into always-inline functions.

2010-01-06  Nick Clifton  <nickc@redhat.com>

	* config/rx/rx.h (enum rx_cpu_type): Add RX200.
	(CC1_SPEC): Issue an error message if -mcpu=rx200 and -fpu are
	used together.
	(OVERRIDE_OPTIONS): Delete.
	(OPTIMIZATION_OPTIONS): Define.
	(ALLOW_RX_FPU_INSNS): Define only in terms of -fpu option.
	* config/rx/rx.c (rx_handle_option): Issue an error message if
	-mcpu=rx200 and -fpu are used together.
	(rx_set_optimization_options): New function.  Issue an error
	message if an optimization attribute attempts to reset the FPU/
	math optimization pairing.
	* config/rx/rx-protos.h (rx_set_optimization_options): Prototype.
	* config/rx/rx.opt: Set the default to 32-bit doubles.
	* config/rx/t-rx: Add multilibs for -nofpu option.
	* doc/invoke.texi: Update documentation of RX options.

2010-01-06  Richard Guenther  <rguenther@suse.de>

	* tree-ssa-pre.c (name_to_id): New global.
	(alloc_expression_id): Simplify SSA name handling.
	(lookup_expression_id): Likewise.
	(init_pre): Zero name_to_id.
	(fini_pre): Free it.

2010-01-06  Uros Bizjak  <ubizjak@gmail.com>

	* ifcvt.c (if_convert): Output slim multiple dumps with TDF_SLIM.

2010-01-05  H.J. Lu  <hongjiu.lu@intel.com>

	PR target/42542
	* config/i386/sse.md (smaxv2di3): New.
	(umaxv2di3): Likewise.
	(sminv2di3): Likewise.
	(uminv2di3): Likewise.

2010-01-05  Eric Botcazou  <ebotcazou@adacore.com>

	PR target/42564
	* config/sparc/sparc.h (SPARC_SYMBOL_REF_TLS_P): Delete.
	* config/sparc/sparc-protos.h (legitimize_pic_address): Likewise.
	(legitimize_tls_address): Likewise.
	(sparc_tls_referenced_p): Likewise.
	* config/sparc/sparc.c (sparc_expand_move): Use legitimize_tls_address
	and adjust calls to legitimize_pic_address.
	(legitimate_constant_p) Use sparc_tls_referenced_p.
	(legitimate_pic_operand_p): Likewise.
	(sparc_legitimate_address_p): Do not use SPARC_SYMBOL_REF_TLS_P.
	(sparc_tls_symbol_ref_1): Delete.
	(sparc_tls_referenced_p): Make static, recognize specific patterns.
	(legitimize_tls_address): Make static, handle CONST patterns.
	(legitimize_pic_address): Make static, remove unused parameter and
	adjust recursive calls.
	(sparc_legitimize_address): Make static, use sparc_tls_referenced_p
	and adjust call to legitimize_pic_address.
	(sparc_output_mi_thunk): Likewise.

2010-01-05  Paolo Bonzini  <bonzini@gnu.rg>
	    H.J. Lu  <hongjiu.lu@intel.com>

	PR target/42542
	* config/i386/i386.c (ix86_expand_int_vcond): Convert GTU to GT
	for V4SI and V2DI by subtracting (-(INT MAX) - 1) from both
	operands to make them signed.

	Revert:
	2010-01-04  H.J. Lu  <hongjiu.lu@intel.com>

	PR target/42542
	* config/i386/i386.c (ix86_expand_int_vcond): Don't convert
	GTU to GT for V4SI and V2DI.

	* config/i386/sse.md (umaxv4si3): Enabled for SSE4.1 and XOP.
	(umin<mode>3): Removed.
	(uminv8hi3): New.
	(uminv4si3): Likewise.

2010-01-05  Martin Jambor  <mjambor@suse.cz>

	PR tree-optimization/42462
	* ipa-inline.c (compute_inline_parameters): Pass node->decl instead of
	current_function_decl to helper functions and macros.

2010-01-05  Rainer Orth  <ro@CeBiTec.Uni-Bielefeld.DE>

	PR bootstrap/41771
	* flags.h: Don't include real.h.
	(HONOR_NANS, HONOR_SNANS, HONOR_INFINITIES, HONOR_SIGNED_ZEROS,
	HONOR_SIGN_DEPENDENT_ROUNDING): Move ...
	* real.h (HONOR_NANS, HONOR_SNANS, HONOR_INFINITIES,
	HONOR_SIGNED_ZEROS, HONOR_SIGN_DEPENDENT_ROUNDING): ... here.
	* dominance.c: Update copyright.
	* gimple.c (walk_gimple_op): Remove inline.
	* tree-ssa-reassoc.c: Include real.h.
	* Makefile.in (FLAGS_H): Remove $(REAL_H).
	(tree-ssa-reassoc.o): Depend on $(REAL_H).

2010-01-05  Nick Clifton  <nickc@redhat.com>

	* config/rx/rx.c (rx_get_stack_layout): Fix allocation of second
	register to push into the stack frame when the accumulator has to
	be saved during interrupts.

2010-01-05  Eric Fisher  <joefoxreal@gmail.com>

	* doc/invoke.texi: Remove the documentation about option
	-Wunreachable-code.
	* common.opt (Wunreachable-code):  Preserved for backward
	compatibility.
	* tree-cfg.c: Remove the implementation of -Wunreachable-code.
	* opts.c (common_handle_option): Add OPT_Wunreachable_code to
	the backward compatibility flag section.

2010-01-05  Richard Guenther  <rguenther@suse.de>

	* tree-ssa-pre.c (bitmap_value_insert_into_set): Optimize.

2010-01-05  Jakub Jelinek  <jakub@redhat.com>

	PR other/42611
	* cfgexpand.c (expand_one_var): Diagnose too large variables.

	PR tree-optimization/42508
	* tree-sra.c (convert_callers): Check for recursive call
	by comparing cgraph nodes instead of decls.
	(modify_function): Call ipa_modify_formal_parameters also
	on all same_body aliases.

	* cgraphunit.c (cgraph_materialize_all_clones): Compare
	cgraph nodes when checking for same_body aliases.

2010-01-05  Richard Guenther  <rguenther@suse.de>

	* tree-ssa-pre.c (get_or_alloc_expr_for_name): Avoid redundant
	allocation and lookup.
	(get_or_alloc_expr_for_constant): Likewise.
	(phi_translate): Sink allocation.

2010-01-04  Richard Guenther  <rguenther@suse.de>

	* tree-ssa-sccvn.c (get_or_alloc_constant_value_id): Allocate
	a new entry only if needed.
	* tree-ssa-dom.c (lookup_avail_expr): Likewise.
	* tree-ssa-coalesce.c (find_coalesce_pair): Avoid one
	hashtable lookup.
	* tree-ssa-pre.c (sorted_array_from_bitmap_set): Pre-allocate
	the result array.
	(phi_translate): Handle CONSTANTs early.

2010-01-04  Martin Jambor  <mjambor@suse.cz>

	PR tree-optimization/42398
	* tree-sra.c (struct access): Removed flag grp_different_types.
	(dump_access): Do not dump the removed flag.
	(sort_and_splice_var_accesses): Do not set the removed flag.
	(sra_modify_expr): Check for type compatibility directly.

2010-01-04  Martin Jambor  <mjambor@suse.cz>

	PR tree-optimization/42366
	* ipa-cp.c (ipcp_init_stage): Always call ipa_compute_jump_functions on
	edges with variable number of parameters.
	* ipa-prop.c (ipa_write_node_info): Stream out uses_analysis_done
	flag instead of asserting it.
	(ipa_read_node_info): Read uses_analysis_done flag.

2010-01-04  Richard Guenther  <rguenther@suse.de>

	* tree-ssa-sccvn.c (vn_reference_op_compute_hash): Use
	iterative_hash_* as intended.
	(vn_reference_compute_hash): Likewise.  Simplify hashing
	SSA names.
	(vn_reference_lookup_2): Likewise.
	(vn_nary_op_compute_hash): Likewise.
	(vn_phi_compute_hash): Likewise.
	(expressions_equal_p): Remove strange code.
	* tree-ssa-pre.c (pre_expr_eq): Use gcc_unreachable ().
	(pre_expr_hash): Likewise.  Simplify hashing SSA names.
	(bitmap_insert_into_set_1): Take value-id as parameter.
	(add_to_value): Pass it.
	(bitmap_insert_into_set): Likewise.
	(bitmap_value_insert_into_set): Likewise.  Remove redundant check.

2010-01-04  Jakub Jelinek  <jakub@redhat.com>

	PR driver/42442
	* gcc.c (SWITCH_IGNORE_PERMANENTLY): Define.
	(do_self_spec): For switches with SWITCH_IGNORE set set also
	SWITCH_IGNORE_PERMANENTLY.
	(check_live_switch): Check SWITCH_IGNORE_PERMANENTLY instead
	of SWITCH_IGNORE.

2010-01-04  Rafael Avila de Espindola  <espindola@google.com>

	* lto-streamer-out.c (output_unreferenced_globals): Output the full
	tree of an unreferenced global var.

2010-01-04  H.J. Lu  <hongjiu.lu@intel.com>

	PR target/42542
	* config/i386/i386.c (ix86_expand_int_vcond): Don't convert
	GTU to GT for V4SI and V2DI.

	* config/i386/sse.md (umaxv4si3): Enabled for SSE4.1 and XOP.
	(umin<mode>3): Removed.
	(uminv8hi3): New.
	(uminv4si3): Likewise.

2010-01-04  H.J. Lu  <hongjiu.lu@intel.com>

	PR lto/42581
	* collect2.c (main): Turn on trace in collect2 if -v is passed
	to gcc with LTO.

2010-01-03  Jerry Quinn  <jlquinn@optonline.net>

	* doc/c-tree.texi (RETURN_STMT): Change to RETURN_EXPR.  Update
	description of expression operand.

2010-01-03  Andrew Jenner  <andrew@codesourcery.com>

	* configure.ac: Add install-html to target_list for Make-hooks.
	* configure: Regenerate.
	* fortran/Make-lang.in (F95_HTMLFILES): New.
	(fortran.html): Use it.
	(fortran.install-html): New.
	* Makefile.in (install-html): Add lang.install-html.
	* java/Make-lang.in (JAVA_HTMLFILES): New.
	(java.html): Use it.
	(java.install-html): New.
	* objc/Make-lang.in (objc.install-html): New.
	* objcp/Make-lang.in (obj-c++.install-html): New.
	* cp/Make-lang.in (c++.install-html): New.
	* ada/gcc-interface/Make-lang.in (ada.install-html): New.
	* lto/Make-lang.in (lto.install-html): New.

2010-01-03  H.J. Lu  <hongjiu.lu@intel.com>

	PR lto/42520
	* gcc.c (LINK_COMMAND_SPEC): Pass -m* and -v to -plugin-opt.

2009-01-03  Steven Bosscher  <steven@gcc.gnu.org>

	PR rtl-optimization/41862
	* store-motion.c (store_killed_in_insn, compute_store_table,
	remove_reachable_equiv_notes, replace_store_insn,
	build_store_vectors): Ignore all DEBUG_INSNs.

2010-01-03  H.J. Lu  <hongjiu.lu@intel.com>

	PR lto/41564
	* common.opt: Add dumpdir.

	* gcc.c (cc1_options): Add "-dumpbase %B" only if -dumpbase
	isn't specified.
	(option_map): Add --dumpdir.

	* gcc.h (DEFAULT_WORD_SWITCH_TAKES_ARG): Add dumpdir.

	* lto-wrapper.c (run_gcc): Add -dumpbase and -dumpdir for -o.

	* opts.c (decode_options): Try dump_dir_name first if
	dump_base_name isn't an absolute path.
	(common_handle_option): Handle OPT_dumpdir.

	* toplev.c (dump_dir_name): New.
	(print_switch_values): Also ignore -dumpdir.

	* toplev.h (dump_dir_name): New.

2010-01-03  Richard Guenther  <rguenther@suse.de>

	PR tree-optimization/42589
	* tree-ssa-math-opts.c (execute_optimize_bswap): Allow
	double-word expansion of bswap32.

2010-01-03  Steven Bosscher  <steven@gcc.gnu.org>

	* postreload-gcse.c (insert_expr_in_table): Replace BLOCK_NUM
	with BLOCK_FOR_INSN.
	* auto-inc-dec.c (attempt_change, get_next_ref, find_inc): Likewise.
	* ifcvt.c (noce_get_alt_condition, noce_try_abs,
	noce_process_if_block): Likewise.
	* gcse.c (compute_local_properties, insert_expr_in_table,
	insert_set_in_table, canon_list_insert, find_avail_set,
	pre_insert_copy_insn): Likewise.

	* basic-block.h (BLOCK_NUM): Move from here...
	* sched-int.h (BLOCK_NUM): ... to here to localize it in the scheduler.

2010-01-03  Richard Guenther  <rguenther@suse.de>

	PR tree-optimization/42438
	* tree-ssa-pre.c (struct bb_bitmap_sets): Add
	contains_may_not_return_call flag.
	(BB_MAY_NOTRETURN): New.
	(valid_in_sets): Trapping nary operations are not valid
	in blocks that may not return.
	(insert_into_preds_of_block): Remove check for trapping
	expressions.
	(compute_avail): Compute also BB_MAY_NOTRETURN.

2010-01-03  Gerald Pfeifer  <gerald@pfeifer.com>

	* doc/invoke.texi: Add 2010 to copyright years.

2010-01-03  Eric Botcazou  <ebotcazou@adacore.com>

	* config/sparc/sparc.c: Fix formatting nits.

2010-01-02  Gerald Pfeifer  <gerald@pfeifer.com>
	    Alexander Monakov  <amonakov@ispras.ru>

	* doc/invoke.texi (Optimize Options): Reword introduction a bit.

2010-01-02  Richard Guenther  <rguenther@suse.de>

	PR middle-end/42577
	* tree-vrp.c (check_all_array_refs): Skip non-excutable blocks.
	(simplify_switch_using_ranges): Mark to be removed edges
	as non-executable.

2010-01-02  John David Anglin  <dave.anglin@nrc-cnrc.gc.ca>

	* config/pa/t-slibgcc-dwarf-ver (SHLIB_SOVERSION): Bump by two.

	* collect2.c (scan_libraries): Add missing argument in call to
	scan_prog_file.

2010-01-02  Uros Bizjak  <ubizjak@gmail.com>

	PR target/42448
	* config/alpha/predicates.md (aligned_memory_operand): Return false
	for CQImode.
	(unaligned_memory_operand): Return true for CQImode.
	* config/alpha/alpha.c (get_aligned_mem): Assert that location
	doesn not cross aligned SImode word boundary.

2010-01-02  Anatoly Sokolov  <aesok@post.ru>

	* config/avr/avr.h (REG_OK_FOR_BASE_P, REG_OK_FOR_INDEX_P, XEXP_):
	Remove.
	* config/avr/avr-protos.h (avr_init_once, avr_optimization_options,
	avr_change_section, avr_reg_class_from_letter) : Remove declaration.

2010-01-02  Richard Guenther  <rguenther@suse.de>

	PR lto/41597
	* toplev.c (compile_file): Emit LTO marker properly.  Change
	it to __gnu_lto_v1.
	* collect2.c (scan_prog_file): Adjust for changed LTO marker.

2010-01-01  Richard Guenther  <rguenther@suse.de>

	PR debug/42455
	* tree-sra.c (analyze_all_variable_accesses): Work in DECL_UID order.

2010-01-01  Richard Guenther  <rguenther@suse.de>

	PR c/42570
	* c-decl.c (grokdeclarator): For zero-size arrays force
	structural equality checks as layout_type does.

2010-01-01  H.J. Lu  <hongjiu.lu@intel.com>

	* builtins.c: Update copyright to 2010.

2010-01-01  H.J. Lu  <hongjiu.lu@intel.com>

	PR lto/42531
	* lto-streamer-out.c (produce_asm): Revert the last change.
	(copy_function): Likewise.

	* lto-streamer.c (lto_get_section_name): Skip any leading
	asterisk in name.

2010-01-01  Richard Guenther  <rguenther@suse.de>

	PR middle-end/42559
	* builtins.c (get_object_alignment): Do not use DECL_ALIGN
	for LABEL_DECLs.


Copyright (C) 2010 Free Software Foundation, Inc.

Copying and distribution of this file, with or without modification,
are permitted in any medium without royalty provided the copyright
notice and this notice are preserved.
